/* AutostartInfo.c generated by valac 0.56.18, the Vala compiler
 * generated from AutostartInfo.vala, do not modify */

/*  xdg-autostart
    Copyright (C) 2014-2017  Fabrice thiroux

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author:
    Fabrice thiroux <fabrice.thiroux@free.fr>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_AUTOSTART_INFO (autostart_info_get_type ())
typedef struct _AutostartInfo AutostartInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AutostartInfo {
	gchar* filename;
	gboolean visibility;
	gint delay;
	gchar* executable;
};

VALA_EXTERN GType autostart_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AutostartInfo* autostart_info_dup (const AutostartInfo* self);
VALA_EXTERN void autostart_info_free (AutostartInfo* self);
VALA_EXTERN void autostart_info_copy (const AutostartInfo* self,
                          AutostartInfo* dest);
VALA_EXTERN void autostart_info_destroy (AutostartInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (AutostartInfo, autostart_info_destroy)
VALA_EXTERN gboolean autostart_info_is_launchable (AutostartInfo *self);
VALA_EXTERN gchar* autostart_info_to_string (AutostartInfo *self);

gboolean
autostart_info_is_launchable (AutostartInfo *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 26 "../AutostartInfo.vala"
	if ((*self).visibility) {
#line 74 "AutostartInfo.c"
		const gchar* _tmp1_;
#line 26 "../AutostartInfo.vala"
		_tmp1_ = (*self).executable;
#line 26 "../AutostartInfo.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 80 "AutostartInfo.c"
	} else {
#line 26 "../AutostartInfo.vala"
		_tmp0_ = FALSE;
#line 84 "AutostartInfo.c"
	}
#line 26 "../AutostartInfo.vala"
	result = _tmp0_;
#line 26 "../AutostartInfo.vala"
	return result;
#line 90 "AutostartInfo.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 103 "AutostartInfo.c"
}

gchar*
autostart_info_to_string (AutostartInfo *self)
{
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* result;
#line 31 "../AutostartInfo.vala"
	if (autostart_info_is_launchable (&(*self))) {
#line 115 "AutostartInfo.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 32 "../AutostartInfo.vala"
		_tmp0_ = (*self).filename;
#line 32 "../AutostartInfo.vala"
		_tmp1_ = string_to_string (_tmp0_);
#line 32 "../AutostartInfo.vala"
		_tmp2_ = g_strdup_printf ("%i", (*self).delay);
#line 32 "../AutostartInfo.vala"
		_tmp3_ = _tmp2_;
#line 32 "../AutostartInfo.vala"
		_tmp4_ = (*self).executable;
#line 32 "../AutostartInfo.vala"
		_tmp5_ = string_to_string (_tmp4_);
#line 32 "../AutostartInfo.vala"
		_tmp6_ = g_strconcat (_tmp1_, ": Delayed by ", _tmp3_, " s | ", _tmp5_, NULL);
#line 32 "../AutostartInfo.vala"
		_tmp7_ = _tmp6_;
#line 32 "../AutostartInfo.vala"
		_g_free0 (_tmp3_);
#line 32 "../AutostartInfo.vala"
		result = _tmp7_;
#line 32 "../AutostartInfo.vala"
		return result;
#line 146 "AutostartInfo.c"
	}
#line 35 "../AutostartInfo.vala"
	_tmp8_ = (*self).filename;
#line 35 "../AutostartInfo.vala"
	_tmp9_ = string_to_string (_tmp8_);
#line 35 "../AutostartInfo.vala"
	_tmp10_ = g_strconcat (_tmp9_, ": Ignored", NULL);
#line 35 "../AutostartInfo.vala"
	result = _tmp10_;
#line 35 "../AutostartInfo.vala"
	return result;
#line 158 "AutostartInfo.c"
}

void
autostart_info_copy (const AutostartInfo* self,
                     AutostartInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 19 "../AutostartInfo.vala"
	_tmp0_ = (*self).filename;
#line 19 "../AutostartInfo.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 19 "../AutostartInfo.vala"
	_g_free0 ((*dest).filename);
#line 19 "../AutostartInfo.vala"
	(*dest).filename = _tmp1_;
#line 19 "../AutostartInfo.vala"
	(*dest).visibility = (*self).visibility;
#line 19 "../AutostartInfo.vala"
	(*dest).delay = (*self).delay;
#line 19 "../AutostartInfo.vala"
	_tmp2_ = (*self).executable;
#line 19 "../AutostartInfo.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 19 "../AutostartInfo.vala"
	_g_free0 ((*dest).executable);
#line 19 "../AutostartInfo.vala"
	(*dest).executable = _tmp3_;
#line 189 "AutostartInfo.c"
}

void
autostart_info_destroy (AutostartInfo* self)
{
#line 20 "../AutostartInfo.vala"
	_g_free0 ((*self).filename);
#line 23 "../AutostartInfo.vala"
	_g_free0 ((*self).executable);
#line 199 "AutostartInfo.c"
}

AutostartInfo*
autostart_info_dup (const AutostartInfo* self)
{
	AutostartInfo* dup;
#line 19 "../AutostartInfo.vala"
	dup = g_new0 (AutostartInfo, 1);
#line 19 "../AutostartInfo.vala"
	autostart_info_copy (self, dup);
#line 19 "../AutostartInfo.vala"
	return dup;
#line 212 "AutostartInfo.c"
}

void
autostart_info_free (AutostartInfo* self)
{
#line 19 "../AutostartInfo.vala"
	autostart_info_destroy (self);
#line 19 "../AutostartInfo.vala"
	g_free (self);
#line 222 "AutostartInfo.c"
}

static GType
autostart_info_get_type_once (void)
{
	GType autostart_info_type_id;
	autostart_info_type_id = g_boxed_type_register_static ("AutostartInfo", (GBoxedCopyFunc) autostart_info_dup, (GBoxedFreeFunc) autostart_info_free);
	return autostart_info_type_id;
}

GType
autostart_info_get_type (void)
{
	static volatile gsize autostart_info_type_id__once = 0;
	if (g_once_init_enter (&autostart_info_type_id__once)) {
		GType autostart_info_type_id;
		autostart_info_type_id = autostart_info_get_type_once ();
		g_once_init_leave (&autostart_info_type_id__once, autostart_info_type_id);
	}
	return autostart_info_type_id__once;
}

