/* AutostartInfoBuilder.c generated by valac 0.56.18, the Vala compiler
 * generated from AutostartInfoBuilder.vala, do not modify */

/*  xdg-autostart
    Copyright (C) 2014-2017  Fabrice thiroux

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Author:
    Fabrice thiroux <fabrice.thiroux@free.fr>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

#define AUTOSTART_INFO_BUILDER_ENTRY "Desktop Entry"
#define AUTOSTART_INFO_BUILDER_SHOWIN "OnlyShowIn"
#define AUTOSTART_INFO_BUILDER_HIDEIN "NotShowIn"
#define AUTOSTART_INFO_BUILDER_DELAY "X-GNOME-Autostart-Delay"
#define AUTOSTART_INFO_BUILDER_TRYEXEC "TryExec"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_AUTOSTART_INFO_BUILDER (autostart_info_builder_get_type ())
#define AUTOSTART_INFO_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilder))
#define AUTOSTART_INFO_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilderClass))
#define IS_AUTOSTART_INFO_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AUTOSTART_INFO_BUILDER))
#define IS_AUTOSTART_INFO_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AUTOSTART_INFO_BUILDER))
#define AUTOSTART_INFO_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilderClass))

typedef struct _AutostartInfoBuilder AutostartInfoBuilder;
typedef struct _AutostartInfoBuilderClass AutostartInfoBuilderClass;
typedef struct _AutostartInfoBuilderPrivate AutostartInfoBuilderPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_AUTOSTART_INFO (autostart_info_get_type ())
typedef struct _AutostartInfo AutostartInfo;
typedef struct _ParamSpecAutostartInfoBuilder ParamSpecAutostartInfoBuilder;

struct _AutostartInfoBuilder {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AutostartInfoBuilderPrivate * priv;
};

struct _AutostartInfoBuilderClass {
	GTypeClass parent_class;
	void (*finalize) (AutostartInfoBuilder *self);
};

struct _AutostartInfoBuilderPrivate {
	gchar* desktop;
	GKeyFile* keyfile;
};

struct _AutostartInfo {
	gchar* filename;
	gboolean visibility;
	gint delay;
	gchar* executable;
};

struct _ParamSpecAutostartInfoBuilder {
	GParamSpec parent_instance;
};

static gint AutostartInfoBuilder_private_offset;
static gpointer autostart_info_builder_parent_class = NULL;

VALA_EXTERN gpointer autostart_info_builder_ref (gpointer instance);
VALA_EXTERN void autostart_info_builder_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_autostart_info_builder (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void value_set_autostart_info_builder (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void value_take_autostart_info_builder (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer value_get_autostart_info_builder (const GValue* value);
VALA_EXTERN GType autostart_info_builder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AutostartInfoBuilder, autostart_info_builder_unref)
VALA_EXTERN AutostartInfoBuilder* autostart_info_builder_new (const gchar* desktop);
VALA_EXTERN AutostartInfoBuilder* autostart_info_builder_construct (GType object_type,
                                                        const gchar* desktop);
static gboolean autostart_info_builder_load_file (AutostartInfoBuilder* self,
                                           const gchar* path);
static gboolean autostart_info_builder_get_visibility (AutostartInfoBuilder* self);
static gboolean autostart_info_builder_find_desktop (AutostartInfoBuilder* self,
                                              const gchar* category,
                                              GKeyFile* kf,
                                              const gchar* desktop);
static gchar* autostart_info_builder_get_executable_name (AutostartInfoBuilder* self);
static gboolean autostart_info_builder_tryexec_is_validated (AutostartInfoBuilder* self,
                                                      GKeyFile* kf);
static gint autostart_info_builder_get_delay (AutostartInfoBuilder* self);
VALA_EXTERN GType autostart_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AutostartInfo* autostart_info_dup (const AutostartInfo* self);
VALA_EXTERN void autostart_info_free (AutostartInfo* self);
VALA_EXTERN void autostart_info_copy (const AutostartInfo* self,
                          AutostartInfo* dest);
VALA_EXTERN void autostart_info_destroy (AutostartInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (AutostartInfo, autostart_info_destroy)
VALA_EXTERN void autostart_info_builder_build (AutostartInfoBuilder* self,
                                   const gchar* path,
                                   AutostartInfo* result);
static void autostart_info_builder_finalize (AutostartInfoBuilder * obj);
static GType autostart_info_builder_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
autostart_info_builder_get_instance_private (AutostartInfoBuilder* self)
{
	return G_STRUCT_MEMBER_P (self, AutostartInfoBuilder_private_offset);
}

AutostartInfoBuilder*
autostart_info_builder_construct (GType object_type,
                                  const gchar* desktop)
{
	AutostartInfoBuilder* self = NULL;
	gchar* _tmp0_;
#line 32 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (desktop != NULL, NULL);
#line 32 "../AutostartInfoBuilder.vala"
	self = (AutostartInfoBuilder*) g_type_create_instance (object_type);
#line 33 "../AutostartInfoBuilder.vala"
	_tmp0_ = g_strdup (desktop);
#line 33 "../AutostartInfoBuilder.vala"
	_g_free0 (self->priv->desktop);
#line 33 "../AutostartInfoBuilder.vala"
	self->priv->desktop = _tmp0_;
#line 32 "../AutostartInfoBuilder.vala"
	return self;
#line 172 "AutostartInfoBuilder.c"
}

AutostartInfoBuilder*
autostart_info_builder_new (const gchar* desktop)
{
#line 32 "../AutostartInfoBuilder.vala"
	return autostart_info_builder_construct (TYPE_AUTOSTART_INFO_BUILDER, desktop);
#line 180 "AutostartInfoBuilder.c"
}

static gboolean
autostart_info_builder_load_file (AutostartInfoBuilder* self,
                                  const gchar* path)
{
	gboolean _tmp5_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 36 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 194 "AutostartInfoBuilder.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
#line 38 "../AutostartInfoBuilder.vala"
		_tmp1_ = self->priv->keyfile;
#line 38 "../AutostartInfoBuilder.vala"
		_tmp0_ = g_key_file_load_from_file (_tmp1_, path, G_KEY_FILE_NONE, &_inner_error0_);
#line 38 "../AutostartInfoBuilder.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 204 "AutostartInfoBuilder.c"
			goto __catch0_g_error;
		}
#line 38 "../AutostartInfoBuilder.vala"
		result = _tmp0_;
#line 38 "../AutostartInfoBuilder.vala"
		return result;
#line 211 "AutostartInfoBuilder.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 37 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 37 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 41 "../AutostartInfoBuilder.vala"
		_tmp2_ = stdout;
#line 41 "../AutostartInfoBuilder.vala"
		_tmp3_ = _error_;
#line 41 "../AutostartInfoBuilder.vala"
		_tmp4_ = _tmp3_->message;
#line 41 "../AutostartInfoBuilder.vala"
		fprintf (_tmp2_, "Error : %s", _tmp4_);
#line 42 "../AutostartInfoBuilder.vala"
		result = FALSE;
#line 42 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 42 "../AutostartInfoBuilder.vala"
		return result;
#line 238 "AutostartInfoBuilder.c"
	}
	__finally0:
#line 37 "../AutostartInfoBuilder.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../AutostartInfoBuilder.vala"
	g_clear_error (&_inner_error0_);
#line 37 "../AutostartInfoBuilder.vala"
	return _tmp5_;
#line 247 "AutostartInfoBuilder.c"
}

/**
     * Returns the visibility of the desktop file
     *
     * Not visible if:
     *  - it doesn't exists in OnlyShowIn list
     *  - it exists in NotShowIn list
     *
     * @returns true if desktop file is visible, false otherwise.
     */
static gboolean
autostart_info_builder_get_visibility (AutostartInfoBuilder* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 55 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "AutostartInfoBuilder.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
#line 57 "../AutostartInfoBuilder.vala"
		_tmp1_ = self->priv->keyfile;
#line 57 "../AutostartInfoBuilder.vala"
		_tmp0_ = g_key_file_has_key (_tmp1_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_SHOWIN, &_inner_error0_);
#line 57 "../AutostartInfoBuilder.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 276 "AutostartInfoBuilder.c"
			gboolean _tmp2_ = FALSE;
#line 57 "../AutostartInfoBuilder.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 280 "AutostartInfoBuilder.c"
				goto __catch0_g_key_file_error;
			}
#line 57 "../AutostartInfoBuilder.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../AutostartInfoBuilder.vala"
			g_clear_error (&_inner_error0_);
#line 57 "../AutostartInfoBuilder.vala"
			return _tmp2_;
#line 289 "AutostartInfoBuilder.c"
		}
#line 57 "../AutostartInfoBuilder.vala"
		if (_tmp0_) {
#line 293 "AutostartInfoBuilder.c"
			GKeyFile* _tmp3_;
			const gchar* _tmp4_;
#line 58 "../AutostartInfoBuilder.vala"
			_tmp3_ = self->priv->keyfile;
#line 58 "../AutostartInfoBuilder.vala"
			_tmp4_ = self->priv->desktop;
#line 58 "../AutostartInfoBuilder.vala"
			result = autostart_info_builder_find_desktop (self, AUTOSTART_INFO_BUILDER_SHOWIN, _tmp3_, _tmp4_);
#line 58 "../AutostartInfoBuilder.vala"
			return result;
#line 304 "AutostartInfoBuilder.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 56 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 56 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 61 "../AutostartInfoBuilder.vala"
		_tmp5_ = _error_;
#line 61 "../AutostartInfoBuilder.vala"
		_tmp6_ = _tmp5_->message;
#line 61 "../AutostartInfoBuilder.vala"
		g_warning ("AutostartInfoBuilder.vala:61: %s", _tmp6_);
#line 56 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 325 "AutostartInfoBuilder.c"
	}
	__finally0:
#line 56 "../AutostartInfoBuilder.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 330 "AutostartInfoBuilder.c"
		gboolean _tmp7_ = FALSE;
#line 56 "../AutostartInfoBuilder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../AutostartInfoBuilder.vala"
		g_clear_error (&_inner_error0_);
#line 56 "../AutostartInfoBuilder.vala"
		return _tmp7_;
#line 338 "AutostartInfoBuilder.c"
	}
	{
		gboolean _tmp8_ = FALSE;
		GKeyFile* _tmp9_;
#line 65 "../AutostartInfoBuilder.vala"
		_tmp9_ = self->priv->keyfile;
#line 65 "../AutostartInfoBuilder.vala"
		_tmp8_ = g_key_file_has_key (_tmp9_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_HIDEIN, &_inner_error0_);
#line 65 "../AutostartInfoBuilder.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 349 "AutostartInfoBuilder.c"
			gboolean _tmp10_ = FALSE;
#line 65 "../AutostartInfoBuilder.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 353 "AutostartInfoBuilder.c"
				goto __catch1_g_key_file_error;
			}
#line 65 "../AutostartInfoBuilder.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../AutostartInfoBuilder.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../AutostartInfoBuilder.vala"
			return _tmp10_;
#line 362 "AutostartInfoBuilder.c"
		}
#line 65 "../AutostartInfoBuilder.vala"
		if (_tmp8_) {
#line 366 "AutostartInfoBuilder.c"
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
#line 66 "../AutostartInfoBuilder.vala"
			_tmp11_ = self->priv->keyfile;
#line 66 "../AutostartInfoBuilder.vala"
			_tmp12_ = self->priv->desktop;
#line 66 "../AutostartInfoBuilder.vala"
			result = !autostart_info_builder_find_desktop (self, AUTOSTART_INFO_BUILDER_HIDEIN, _tmp11_, _tmp12_);
#line 66 "../AutostartInfoBuilder.vala"
			return result;
#line 377 "AutostartInfoBuilder.c"
		}
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 64 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 64 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 69 "../AutostartInfoBuilder.vala"
		_tmp13_ = _error_;
#line 69 "../AutostartInfoBuilder.vala"
		_tmp14_ = _tmp13_->message;
#line 69 "../AutostartInfoBuilder.vala"
		g_warning ("AutostartInfoBuilder.vala:69: %s", _tmp14_);
#line 64 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 398 "AutostartInfoBuilder.c"
	}
	__finally1:
#line 64 "../AutostartInfoBuilder.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 403 "AutostartInfoBuilder.c"
		gboolean _tmp15_ = FALSE;
#line 64 "../AutostartInfoBuilder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../AutostartInfoBuilder.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../AutostartInfoBuilder.vala"
		return _tmp15_;
#line 411 "AutostartInfoBuilder.c"
	}
#line 72 "../AutostartInfoBuilder.vala"
	result = TRUE;
#line 72 "../AutostartInfoBuilder.vala"
	return result;
#line 417 "AutostartInfoBuilder.c"
}

/**
     * Check if executable name exists or if TryExec condition is met
     *
     * @returns the executable name or null.
     */
static gchar*
autostart_info_builder_get_executable_name (AutostartInfoBuilder* self)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 80 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 432 "AutostartInfoBuilder.c"
	{
		GKeyFile* _tmp0_;
#line 82 "../AutostartInfoBuilder.vala"
		_tmp0_ = self->priv->keyfile;
#line 82 "../AutostartInfoBuilder.vala"
		if (autostart_info_builder_tryexec_is_validated (self, _tmp0_)) {
#line 439 "AutostartInfoBuilder.c"
			gchar* _tmp1_ = NULL;
			GKeyFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 83 "../AutostartInfoBuilder.vala"
			_tmp2_ = self->priv->keyfile;
#line 83 "../AutostartInfoBuilder.vala"
			_tmp3_ = g_key_file_get_string (_tmp2_, AUTOSTART_INFO_BUILDER_ENTRY, "Exec", &_inner_error0_);
#line 83 "../AutostartInfoBuilder.vala"
			_tmp1_ = _tmp3_;
#line 83 "../AutostartInfoBuilder.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 83 "../AutostartInfoBuilder.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 454 "AutostartInfoBuilder.c"
					goto __catch0_g_key_file_error;
				}
#line 83 "../AutostartInfoBuilder.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../AutostartInfoBuilder.vala"
				g_clear_error (&_inner_error0_);
#line 83 "../AutostartInfoBuilder.vala"
				return NULL;
#line 463 "AutostartInfoBuilder.c"
			}
#line 83 "../AutostartInfoBuilder.vala"
			_tmp4_ = _tmp1_;
#line 83 "../AutostartInfoBuilder.vala"
			_tmp1_ = NULL;
#line 83 "../AutostartInfoBuilder.vala"
			result = _tmp4_;
#line 83 "../AutostartInfoBuilder.vala"
			_g_free0 (_tmp1_);
#line 83 "../AutostartInfoBuilder.vala"
			return result;
#line 475 "AutostartInfoBuilder.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 81 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 81 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 86 "../AutostartInfoBuilder.vala"
		_tmp5_ = _error_;
#line 86 "../AutostartInfoBuilder.vala"
		_tmp6_ = _tmp5_->message;
#line 86 "../AutostartInfoBuilder.vala"
		g_warning ("AutostartInfoBuilder.vala:86: %s", _tmp6_);
#line 81 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 496 "AutostartInfoBuilder.c"
	}
	__finally0:
#line 81 "../AutostartInfoBuilder.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../AutostartInfoBuilder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../AutostartInfoBuilder.vala"
		g_clear_error (&_inner_error0_);
#line 81 "../AutostartInfoBuilder.vala"
		return NULL;
#line 507 "AutostartInfoBuilder.c"
	}
#line 89 "../AutostartInfoBuilder.vala"
	result = NULL;
#line 89 "../AutostartInfoBuilder.vala"
	return result;
#line 513 "AutostartInfoBuilder.c"
}

/**
     * @returns the delay in seconds before program has to be launched
     */
static gint
autostart_info_builder_get_delay (AutostartInfoBuilder* self)
{
	GError* _inner_error0_ = NULL;
	gint result;
#line 95 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 526 "AutostartInfoBuilder.c"
	{
		gboolean _tmp0_ = FALSE;
		GKeyFile* _tmp1_;
#line 97 "../AutostartInfoBuilder.vala"
		_tmp1_ = self->priv->keyfile;
#line 97 "../AutostartInfoBuilder.vala"
		_tmp0_ = g_key_file_has_key (_tmp1_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_DELAY, &_inner_error0_);
#line 97 "../AutostartInfoBuilder.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 536 "AutostartInfoBuilder.c"
			gint _tmp2_ = -1;
#line 97 "../AutostartInfoBuilder.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 540 "AutostartInfoBuilder.c"
				goto __catch0_g_key_file_error;
			}
#line 97 "../AutostartInfoBuilder.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../AutostartInfoBuilder.vala"
			g_clear_error (&_inner_error0_);
#line 97 "../AutostartInfoBuilder.vala"
			return _tmp2_;
#line 549 "AutostartInfoBuilder.c"
		}
#line 97 "../AutostartInfoBuilder.vala"
		if (_tmp0_) {
#line 553 "AutostartInfoBuilder.c"
			gint _tmp3_ = 0;
			GKeyFile* _tmp4_;
#line 98 "../AutostartInfoBuilder.vala"
			_tmp4_ = self->priv->keyfile;
#line 98 "../AutostartInfoBuilder.vala"
			_tmp3_ = g_key_file_get_integer (_tmp4_, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_DELAY, &_inner_error0_);
#line 98 "../AutostartInfoBuilder.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 562 "AutostartInfoBuilder.c"
				gint _tmp5_ = -1;
#line 98 "../AutostartInfoBuilder.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 566 "AutostartInfoBuilder.c"
					goto __catch0_g_key_file_error;
				}
#line 98 "../AutostartInfoBuilder.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../AutostartInfoBuilder.vala"
				g_clear_error (&_inner_error0_);
#line 98 "../AutostartInfoBuilder.vala"
				return _tmp5_;
#line 575 "AutostartInfoBuilder.c"
			}
#line 98 "../AutostartInfoBuilder.vala"
			result = _tmp3_;
#line 98 "../AutostartInfoBuilder.vala"
			return result;
#line 581 "AutostartInfoBuilder.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 96 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 96 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 102 "../AutostartInfoBuilder.vala"
		_tmp6_ = _error_;
#line 102 "../AutostartInfoBuilder.vala"
		_tmp7_ = _tmp6_->message;
#line 102 "../AutostartInfoBuilder.vala"
		g_warning ("AutostartInfoBuilder.vala:102: %s", _tmp7_);
#line 96 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 602 "AutostartInfoBuilder.c"
	}
	__finally0:
#line 96 "../AutostartInfoBuilder.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 607 "AutostartInfoBuilder.c"
		gint _tmp8_ = -1;
#line 96 "../AutostartInfoBuilder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../AutostartInfoBuilder.vala"
		g_clear_error (&_inner_error0_);
#line 96 "../AutostartInfoBuilder.vala"
		return _tmp8_;
#line 615 "AutostartInfoBuilder.c"
	}
#line 105 "../AutostartInfoBuilder.vala"
	result = 0;
#line 105 "../AutostartInfoBuilder.vala"
	return result;
#line 621 "AutostartInfoBuilder.c"
}

void
autostart_info_builder_build (AutostartInfoBuilder* self,
                              const gchar* path,
                              AutostartInfo* result)
{
	AutostartInfo info = {0};
	gchar* _tmp0_;
	AutostartInfo _tmp1_ = {0};
#line 108 "../AutostartInfoBuilder.vala"
	g_return_if_fail (self != NULL);
#line 108 "../AutostartInfoBuilder.vala"
	g_return_if_fail (path != NULL);
#line 110 "../AutostartInfoBuilder.vala"
	_tmp0_ = g_strdup (path);
#line 110 "../AutostartInfoBuilder.vala"
	memset (&_tmp1_, 0, sizeof (AutostartInfo));
#line 110 "../AutostartInfoBuilder.vala"
	_tmp1_.visibility = FALSE;
#line 110 "../AutostartInfoBuilder.vala"
	_g_free0 (_tmp1_.filename);
#line 110 "../AutostartInfoBuilder.vala"
	_tmp1_.filename = _tmp0_;
#line 110 "../AutostartInfoBuilder.vala"
	info = _tmp1_;
#line 115 "../AutostartInfoBuilder.vala"
	if (autostart_info_builder_load_file (self, path)) {
#line 650 "AutostartInfoBuilder.c"
		gchar* _tmp2_;
#line 116 "../AutostartInfoBuilder.vala"
		info.visibility = autostart_info_builder_get_visibility (self);
#line 117 "../AutostartInfoBuilder.vala"
		_tmp2_ = autostart_info_builder_get_executable_name (self);
#line 117 "../AutostartInfoBuilder.vala"
		_g_free0 (info.executable);
#line 117 "../AutostartInfoBuilder.vala"
		info.executable = _tmp2_;
#line 118 "../AutostartInfoBuilder.vala"
		info.delay = autostart_info_builder_get_delay (self);
#line 662 "AutostartInfoBuilder.c"
	}
#line 121 "../AutostartInfoBuilder.vala"
	*result = info;
#line 121 "../AutostartInfoBuilder.vala"
	return;
#line 668 "AutostartInfoBuilder.c"
}

static gboolean
autostart_info_builder_tryexec_is_validated (AutostartInfoBuilder* self,
                                             GKeyFile* kf)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 129 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (kf != NULL, FALSE);
#line 681 "AutostartInfoBuilder.c"
	{
		gboolean _tmp0_ = FALSE;
#line 131 "../AutostartInfoBuilder.vala"
		_tmp0_ = g_key_file_has_key (kf, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_TRYEXEC, &_inner_error0_);
#line 131 "../AutostartInfoBuilder.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 688 "AutostartInfoBuilder.c"
			gboolean _tmp1_ = FALSE;
#line 131 "../AutostartInfoBuilder.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 692 "AutostartInfoBuilder.c"
				goto __catch0_g_key_file_error;
			}
#line 131 "../AutostartInfoBuilder.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../AutostartInfoBuilder.vala"
			g_clear_error (&_inner_error0_);
#line 131 "../AutostartInfoBuilder.vala"
			return _tmp1_;
#line 701 "AutostartInfoBuilder.c"
		}
#line 131 "../AutostartInfoBuilder.vala"
		if (_tmp0_) {
#line 705 "AutostartInfoBuilder.c"
			gchar* tryexec = NULL;
			gchar* _tmp2_;
			const gchar* _tmp4_;
#line 132 "../AutostartInfoBuilder.vala"
			_tmp2_ = g_key_file_get_string (kf, AUTOSTART_INFO_BUILDER_ENTRY, AUTOSTART_INFO_BUILDER_TRYEXEC, &_inner_error0_);
#line 132 "../AutostartInfoBuilder.vala"
			tryexec = _tmp2_;
#line 132 "../AutostartInfoBuilder.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 715 "AutostartInfoBuilder.c"
				gboolean _tmp3_ = FALSE;
#line 132 "../AutostartInfoBuilder.vala"
				if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 719 "AutostartInfoBuilder.c"
					goto __catch0_g_key_file_error;
				}
#line 132 "../AutostartInfoBuilder.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 132 "../AutostartInfoBuilder.vala"
				g_clear_error (&_inner_error0_);
#line 132 "../AutostartInfoBuilder.vala"
				return _tmp3_;
#line 728 "AutostartInfoBuilder.c"
			}
#line 133 "../AutostartInfoBuilder.vala"
			_tmp4_ = tryexec;
#line 133 "../AutostartInfoBuilder.vala"
			if (_tmp4_ != NULL) {
#line 734 "AutostartInfoBuilder.c"
				const gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gboolean _tmp8_;
#line 134 "../AutostartInfoBuilder.vala"
				_tmp5_ = tryexec;
#line 134 "../AutostartInfoBuilder.vala"
				_tmp6_ = g_find_program_in_path (_tmp5_);
#line 134 "../AutostartInfoBuilder.vala"
				_tmp7_ = _tmp6_;
#line 134 "../AutostartInfoBuilder.vala"
				_tmp8_ = _tmp7_ == NULL;
#line 134 "../AutostartInfoBuilder.vala"
				_g_free0 (_tmp7_);
#line 134 "../AutostartInfoBuilder.vala"
				if (_tmp8_) {
#line 135 "../AutostartInfoBuilder.vala"
					result = FALSE;
#line 135 "../AutostartInfoBuilder.vala"
					_g_free0 (tryexec);
#line 135 "../AutostartInfoBuilder.vala"
					return result;
#line 757 "AutostartInfoBuilder.c"
				}
			}
#line 131 "../AutostartInfoBuilder.vala"
			_g_free0 (tryexec);
#line 762 "AutostartInfoBuilder.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 130 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 130 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 141 "../AutostartInfoBuilder.vala"
		_tmp9_ = _error_;
#line 141 "../AutostartInfoBuilder.vala"
		_tmp10_ = _tmp9_->message;
#line 141 "../AutostartInfoBuilder.vala"
		g_warning ("AutostartInfoBuilder.vala:141: %s", _tmp10_);
#line 130 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 783 "AutostartInfoBuilder.c"
	}
	__finally0:
#line 130 "../AutostartInfoBuilder.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 788 "AutostartInfoBuilder.c"
		gboolean _tmp11_ = FALSE;
#line 130 "../AutostartInfoBuilder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../AutostartInfoBuilder.vala"
		g_clear_error (&_inner_error0_);
#line 130 "../AutostartInfoBuilder.vala"
		return _tmp11_;
#line 796 "AutostartInfoBuilder.c"
	}
#line 144 "../AutostartInfoBuilder.vala"
	result = TRUE;
#line 144 "../AutostartInfoBuilder.vala"
	return result;
#line 802 "AutostartInfoBuilder.c"
}

static gboolean
autostart_info_builder_find_desktop (AutostartInfoBuilder* self,
                                     const gchar* category,
                                     GKeyFile* kf,
                                     const gchar* desktop)
{
	gchar** show_list = NULL;
	gint show_list_length1 = 0;
	gint _show_list_size_ = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 148 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (category != NULL, FALSE);
#line 148 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (kf != NULL, FALSE);
#line 148 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (desktop != NULL, FALSE);
#line 824 "AutostartInfoBuilder.c"
	{
		gchar** _tmp0_ = NULL;
		gsize _tmp1_ = 0;
		gchar** _tmp2_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gint _tmp5__length1;
#line 152 "../AutostartInfoBuilder.vala"
		_tmp2_ = g_key_file_get_string_list (kf, AUTOSTART_INFO_BUILDER_ENTRY, category, &_tmp1_, &_inner_error0_);
#line 152 "../AutostartInfoBuilder.vala"
		_tmp0_ = _tmp2_;
#line 152 "../AutostartInfoBuilder.vala"
		_tmp0__length1 = _tmp1_;
#line 152 "../AutostartInfoBuilder.vala"
		__tmp0__size_ = _tmp0__length1;
#line 152 "../AutostartInfoBuilder.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 845 "AutostartInfoBuilder.c"
			gboolean _tmp3_ = FALSE;
#line 152 "../AutostartInfoBuilder.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 849 "AutostartInfoBuilder.c"
				goto __catch0_g_key_file_error;
			}
#line 152 "../AutostartInfoBuilder.vala"
			show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../AutostartInfoBuilder.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../AutostartInfoBuilder.vala"
			g_clear_error (&_inner_error0_);
#line 152 "../AutostartInfoBuilder.vala"
			return _tmp3_;
#line 860 "AutostartInfoBuilder.c"
		}
#line 152 "../AutostartInfoBuilder.vala"
		_tmp4_ = _tmp0_;
#line 152 "../AutostartInfoBuilder.vala"
		_tmp4__length1 = _tmp0__length1;
#line 152 "../AutostartInfoBuilder.vala"
		_tmp0_ = NULL;
#line 152 "../AutostartInfoBuilder.vala"
		_tmp0__length1 = 0;
#line 152 "../AutostartInfoBuilder.vala"
		show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
#line 152 "../AutostartInfoBuilder.vala"
		show_list = _tmp4_;
#line 152 "../AutostartInfoBuilder.vala"
		show_list_length1 = _tmp4__length1;
#line 152 "../AutostartInfoBuilder.vala"
		_show_list_size_ = show_list_length1;
#line 153 "../AutostartInfoBuilder.vala"
		_tmp5_ = show_list;
#line 153 "../AutostartInfoBuilder.vala"
		_tmp5__length1 = show_list_length1;
#line 882 "AutostartInfoBuilder.c"
		{
			gchar** de_collection = NULL;
			gint de_collection_length1 = 0;
			gint _de_collection_size_ = 0;
			gint de_it = 0;
#line 153 "../AutostartInfoBuilder.vala"
			de_collection = _tmp5_;
#line 153 "../AutostartInfoBuilder.vala"
			de_collection_length1 = _tmp5__length1;
#line 153 "../AutostartInfoBuilder.vala"
			for (de_it = 0; de_it < de_collection_length1; de_it = de_it + 1) {
#line 894 "AutostartInfoBuilder.c"
				gchar* _tmp6_;
				gchar* de = NULL;
#line 153 "../AutostartInfoBuilder.vala"
				_tmp6_ = g_strdup (de_collection[de_it]);
#line 153 "../AutostartInfoBuilder.vala"
				de = _tmp6_;
#line 901 "AutostartInfoBuilder.c"
				{
					const gchar* _tmp7_;
#line 154 "../AutostartInfoBuilder.vala"
					_tmp7_ = de;
#line 154 "../AutostartInfoBuilder.vala"
					if (g_strcmp0 (_tmp7_, desktop) == 0) {
#line 155 "../AutostartInfoBuilder.vala"
						result = TRUE;
#line 155 "../AutostartInfoBuilder.vala"
						_g_free0 (de);
#line 155 "../AutostartInfoBuilder.vala"
						_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 155 "../AutostartInfoBuilder.vala"
						show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
#line 155 "../AutostartInfoBuilder.vala"
						return result;
#line 918 "AutostartInfoBuilder.c"
					}
#line 153 "../AutostartInfoBuilder.vala"
					_g_free0 (de);
#line 922 "AutostartInfoBuilder.c"
				}
			}
		}
#line 151 "../AutostartInfoBuilder.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 928 "AutostartInfoBuilder.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 151 "../AutostartInfoBuilder.vala"
		_error_ = _inner_error0_;
#line 151 "../AutostartInfoBuilder.vala"
		_inner_error0_ = NULL;
#line 160 "../AutostartInfoBuilder.vala"
		_tmp8_ = _error_;
#line 160 "../AutostartInfoBuilder.vala"
		_tmp9_ = _tmp8_->message;
#line 160 "../AutostartInfoBuilder.vala"
		g_warning ("AutostartInfoBuilder.vala:160: %s", _tmp9_);
#line 151 "../AutostartInfoBuilder.vala"
		_g_error_free0 (_error_);
#line 948 "AutostartInfoBuilder.c"
	}
	__finally0:
#line 151 "../AutostartInfoBuilder.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 953 "AutostartInfoBuilder.c"
		gboolean _tmp10_ = FALSE;
#line 151 "../AutostartInfoBuilder.vala"
		show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
#line 151 "../AutostartInfoBuilder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../AutostartInfoBuilder.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../AutostartInfoBuilder.vala"
		return _tmp10_;
#line 963 "AutostartInfoBuilder.c"
	}
#line 163 "../AutostartInfoBuilder.vala"
	result = FALSE;
#line 163 "../AutostartInfoBuilder.vala"
	show_list = (_vala_array_free (show_list, show_list_length1, (GDestroyNotify) g_free), NULL);
#line 163 "../AutostartInfoBuilder.vala"
	return result;
#line 971 "AutostartInfoBuilder.c"
}

static void
value_autostart_info_builder_init (GValue* value)
{
#line 21 "../AutostartInfoBuilder.vala"
	value->data[0].v_pointer = NULL;
#line 979 "AutostartInfoBuilder.c"
}

static void
value_autostart_info_builder_free_value (GValue* value)
{
#line 21 "../AutostartInfoBuilder.vala"
	if (value->data[0].v_pointer) {
#line 21 "../AutostartInfoBuilder.vala"
		autostart_info_builder_unref (value->data[0].v_pointer);
#line 989 "AutostartInfoBuilder.c"
	}
}

static void
value_autostart_info_builder_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 21 "../AutostartInfoBuilder.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../AutostartInfoBuilder.vala"
		dest_value->data[0].v_pointer = autostart_info_builder_ref (src_value->data[0].v_pointer);
#line 1001 "AutostartInfoBuilder.c"
	} else {
#line 21 "../AutostartInfoBuilder.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1005 "AutostartInfoBuilder.c"
	}
}

static gpointer
value_autostart_info_builder_peek_pointer (const GValue* value)
{
#line 21 "../AutostartInfoBuilder.vala"
	return value->data[0].v_pointer;
#line 1014 "AutostartInfoBuilder.c"
}

static gchar*
value_autostart_info_builder_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 21 "../AutostartInfoBuilder.vala"
	if (collect_values[0].v_pointer) {
#line 1025 "AutostartInfoBuilder.c"
		AutostartInfoBuilder * object;
		object = collect_values[0].v_pointer;
#line 21 "../AutostartInfoBuilder.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../AutostartInfoBuilder.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1032 "AutostartInfoBuilder.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../AutostartInfoBuilder.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1036 "AutostartInfoBuilder.c"
		}
#line 21 "../AutostartInfoBuilder.vala"
		value->data[0].v_pointer = autostart_info_builder_ref (object);
#line 1040 "AutostartInfoBuilder.c"
	} else {
#line 21 "../AutostartInfoBuilder.vala"
		value->data[0].v_pointer = NULL;
#line 1044 "AutostartInfoBuilder.c"
	}
#line 21 "../AutostartInfoBuilder.vala"
	return NULL;
#line 1048 "AutostartInfoBuilder.c"
}

static gchar*
value_autostart_info_builder_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	AutostartInfoBuilder ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../AutostartInfoBuilder.vala"
	if (!object_p) {
#line 21 "../AutostartInfoBuilder.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1063 "AutostartInfoBuilder.c"
	}
#line 21 "../AutostartInfoBuilder.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../AutostartInfoBuilder.vala"
		*object_p = NULL;
#line 1069 "AutostartInfoBuilder.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../AutostartInfoBuilder.vala"
		*object_p = value->data[0].v_pointer;
#line 1073 "AutostartInfoBuilder.c"
	} else {
#line 21 "../AutostartInfoBuilder.vala"
		*object_p = autostart_info_builder_ref (value->data[0].v_pointer);
#line 1077 "AutostartInfoBuilder.c"
	}
#line 21 "../AutostartInfoBuilder.vala"
	return NULL;
#line 1081 "AutostartInfoBuilder.c"
}

GParamSpec*
param_spec_autostart_info_builder (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	ParamSpecAutostartInfoBuilder* spec;
#line 21 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AUTOSTART_INFO_BUILDER), NULL);
#line 21 "../AutostartInfoBuilder.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../AutostartInfoBuilder.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../AutostartInfoBuilder.vala"
	return G_PARAM_SPEC (spec);
#line 1100 "AutostartInfoBuilder.c"
}

gpointer
value_get_autostart_info_builder (const GValue* value)
{
#line 21 "../AutostartInfoBuilder.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AUTOSTART_INFO_BUILDER), NULL);
#line 21 "../AutostartInfoBuilder.vala"
	return value->data[0].v_pointer;
#line 1110 "AutostartInfoBuilder.c"
}

void
value_set_autostart_info_builder (GValue* value,
                                  gpointer v_object)
{
	AutostartInfoBuilder * old;
#line 21 "../AutostartInfoBuilder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AUTOSTART_INFO_BUILDER));
#line 21 "../AutostartInfoBuilder.vala"
	old = value->data[0].v_pointer;
#line 21 "../AutostartInfoBuilder.vala"
	if (v_object) {
#line 21 "../AutostartInfoBuilder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AUTOSTART_INFO_BUILDER));
#line 21 "../AutostartInfoBuilder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../AutostartInfoBuilder.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../AutostartInfoBuilder.vala"
		autostart_info_builder_ref (value->data[0].v_pointer);
#line 1132 "AutostartInfoBuilder.c"
	} else {
#line 21 "../AutostartInfoBuilder.vala"
		value->data[0].v_pointer = NULL;
#line 1136 "AutostartInfoBuilder.c"
	}
#line 21 "../AutostartInfoBuilder.vala"
	if (old) {
#line 21 "../AutostartInfoBuilder.vala"
		autostart_info_builder_unref (old);
#line 1142 "AutostartInfoBuilder.c"
	}
}

void
value_take_autostart_info_builder (GValue* value,
                                   gpointer v_object)
{
	AutostartInfoBuilder * old;
#line 21 "../AutostartInfoBuilder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AUTOSTART_INFO_BUILDER));
#line 21 "../AutostartInfoBuilder.vala"
	old = value->data[0].v_pointer;
#line 21 "../AutostartInfoBuilder.vala"
	if (v_object) {
#line 21 "../AutostartInfoBuilder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AUTOSTART_INFO_BUILDER));
#line 21 "../AutostartInfoBuilder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../AutostartInfoBuilder.vala"
		value->data[0].v_pointer = v_object;
#line 1163 "AutostartInfoBuilder.c"
	} else {
#line 21 "../AutostartInfoBuilder.vala"
		value->data[0].v_pointer = NULL;
#line 1167 "AutostartInfoBuilder.c"
	}
#line 21 "../AutostartInfoBuilder.vala"
	if (old) {
#line 21 "../AutostartInfoBuilder.vala"
		autostart_info_builder_unref (old);
#line 1173 "AutostartInfoBuilder.c"
	}
}

static void
autostart_info_builder_class_init (AutostartInfoBuilderClass * klass,
                                   gpointer klass_data)
{
#line 21 "../AutostartInfoBuilder.vala"
	autostart_info_builder_parent_class = g_type_class_peek_parent (klass);
#line 21 "../AutostartInfoBuilder.vala"
	((AutostartInfoBuilderClass *) klass)->finalize = autostart_info_builder_finalize;
#line 21 "../AutostartInfoBuilder.vala"
	g_type_class_adjust_private_offset (klass, &AutostartInfoBuilder_private_offset);
#line 1187 "AutostartInfoBuilder.c"
}

static void
autostart_info_builder_instance_init (AutostartInfoBuilder * self,
                                      gpointer klass)
{
	GKeyFile* _tmp0_;
#line 21 "../AutostartInfoBuilder.vala"
	self->priv = autostart_info_builder_get_instance_private (self);
#line 30 "../AutostartInfoBuilder.vala"
	_tmp0_ = g_key_file_new ();
#line 30 "../AutostartInfoBuilder.vala"
	self->priv->keyfile = _tmp0_;
#line 21 "../AutostartInfoBuilder.vala"
	self->ref_count = 1;
#line 1203 "AutostartInfoBuilder.c"
}

static void
autostart_info_builder_finalize (AutostartInfoBuilder * obj)
{
	AutostartInfoBuilder * self;
#line 21 "../AutostartInfoBuilder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AUTOSTART_INFO_BUILDER, AutostartInfoBuilder);
#line 21 "../AutostartInfoBuilder.vala"
	g_signal_handlers_destroy (self);
#line 28 "../AutostartInfoBuilder.vala"
	_g_free0 (self->priv->desktop);
#line 30 "../AutostartInfoBuilder.vala"
	_g_key_file_unref0 (self->priv->keyfile);
#line 1218 "AutostartInfoBuilder.c"
}

static GType
autostart_info_builder_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_autostart_info_builder_init, value_autostart_info_builder_free_value, value_autostart_info_builder_copy_value, value_autostart_info_builder_peek_pointer, "p", value_autostart_info_builder_collect_value, "p", value_autostart_info_builder_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AutostartInfoBuilderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) autostart_info_builder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AutostartInfoBuilder), 0, (GInstanceInitFunc) autostart_info_builder_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType autostart_info_builder_type_id;
	autostart_info_builder_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AutostartInfoBuilder", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AutostartInfoBuilder_private_offset = g_type_add_instance_private (autostart_info_builder_type_id, sizeof (AutostartInfoBuilderPrivate));
	return autostart_info_builder_type_id;
}

GType
autostart_info_builder_get_type (void)
{
	static volatile gsize autostart_info_builder_type_id__once = 0;
	if (g_once_init_enter (&autostart_info_builder_type_id__once)) {
		GType autostart_info_builder_type_id;
		autostart_info_builder_type_id = autostart_info_builder_get_type_once ();
		g_once_init_leave (&autostart_info_builder_type_id__once, autostart_info_builder_type_id);
	}
	return autostart_info_builder_type_id__once;
}

gpointer
autostart_info_builder_ref (gpointer instance)
{
	AutostartInfoBuilder * self;
	self = instance;
#line 21 "../AutostartInfoBuilder.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../AutostartInfoBuilder.vala"
	return instance;
#line 1254 "AutostartInfoBuilder.c"
}

void
autostart_info_builder_unref (gpointer instance)
{
	AutostartInfoBuilder * self;
	self = instance;
#line 21 "../AutostartInfoBuilder.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../AutostartInfoBuilder.vala"
		AUTOSTART_INFO_BUILDER_GET_CLASS (self)->finalize (self);
#line 21 "../AutostartInfoBuilder.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1268 "AutostartInfoBuilder.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

